''Testing
CON
  '--- --- --- --- --- ---  
  'System
  '--- --- --- --- --- ---  
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _ConClkFreq = ((_clkmode - xtal1) >> 6) * _xinfreq
  _Ms_001   = _ConClkFreq / 1_000
  _Us_001   = _ConClkFreq / 1_000_000
  
  '--- --- --- --- --- ---  
  'uSD
  '--- --- --- --- --- ---  
  _sd_DO = 16 
  _sd_CLK = 17 
  _sd_DI = 18 
  _sd_CS = 19 
  _sd_WP = -1 ' -1 ifnot installed.
  _sd_CD = -1 ' -1 ifnot installed.

  _sd_MaxFilesPerDir = 512   'Max number of filenames per dir

  '--- --- --- --- --- ---  
  'RTC
  '--- --- --- --- --- ---  
  _rtc_DAT = 29    ' -1 ifnot installed.
  _rtc_CLK = 28    ' -1 ifnot installed.

  '*** *** *** *** *** *** ***
  '*** Debugging ***
  '*** *** *** *** *** *** ***
  _dbgBaudRate = 250_000


OBJ
  uSD : "SD3.01_FATEngine.spin" 
  STR : "ASCII0_STREngine.spin"
  DBG : "ParallaxSerialTerminal.spin"

VAR
  long sdFiles[_sd_MaxFilesPerDir]   'Array for storing total number of files
  

PUB Main | buffer, i, k

  '*** *** *** *** *** ***
  '*** Debugging ***
  '*** *** *** *** *** ***
  DBG.Start(_dbgBaudRate)
   

  '--- --- --- --- --- --- --- --- ---
  '--- --- uSD Cog --- ---
  '--- --- --- --- --- --- --- --- --- 
  ifnot(uSD.FATEngineStart(_sd_DO, _sd_CLK, _sd_DI, _sd_CS, _sd_WP, _sd_CD, _rtc_DAT, _rtc_CLK, -1))      'SD 3.0
    reboot

  'Mounting the uSD card first
  uSD.mountPartition(0)    'v3.0

  
  '--- Read & store all files on uSD to array
  bytefill(@sdFiles, 0, _sd_MaxFilesPerDir)   

  dbg.Char(0)
  dbg.Str(String("Read from uSD"))
  dbg.Char(13)
  dbg.Str(String("============="))
  dbg.Char(13)
  i := 0

  uSD.listEntries("W")   'v3.0

  repeat while(buffer := uSD.listEntries("N"))   'v3.0
    sdFiles[i++] := buffer
    dbg.Str(buffer)
    dbg.Str(String(" - Cntr: "))
    dbg.Dec(i-1)
    dbg.Str(String(" "))
    dbg.Str(sdFiles[i-1])   '<--Output shows this stored correctly
    dbg.Char(13)

       
  '*** Debugging
  'Reading out to Terminal
  dbg.Char(13)
  dbg.Char(13)
  dbg.Str(String("Reading from Array"))
  dbg.Char(13)
  dbg.Str(String("=================="))
  dbg.Char(13)
  dbg.Str(String("Total files : "))
  dbg.Dec(i)
  dbg.Char(13)
  repeat k from 0 to i
    dbg.Str(sdFiles[k])   '<-- Keeps showing the last file???
    dbg.Char(13)